/*
* Copyright (c) 2017 Fraunhofer FOKUS.
* All rights reserved. This program and the accompanying materials
* are made available under the terms of the
* GNU AGPL v3 which accompanies
* this distribution, and is available at
* http://www.gnu.org/licenses/agpl.txt
*
* Contributors:
*
* Simon Dutkowski Fraunhofer FOKUS
*
* Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
*/

package eu.DECIDEh2020.architect.cloudpatterns;

import org.apache.jena.rdf.model.Model;
import org.apache.jena.rdf.model.ModelFactory;
import org.apache.jena.rdf.model.Resource;

public class DECIDEPatterns {

    public static final String BASE = "http://decideh2020.eu/resources/";

    public static final Resource patternCategories;

    public static final Resource fundamentalCategory;
    public static final Resource developmentCategory;
    public static final Resource optimizationCategory;
    public static final Resource deploymentCategory;

    public static final Resource availability;
    public static final Resource scalability;
    public static final Resource performance;
    public static final Resource cost;
    public static final Resource location;

    static {
        Model m = ModelFactory.createDefaultModel();

        patternCategories = m.createResource(BASE + "patterncategories");

        fundamentalCategory = m.createResource(BASE + "patterncategories/fundamental");
        developmentCategory = m.createResource(BASE + "patterncategories/development");
        optimizationCategory = m.createResource(BASE + "patterncategories/optimization");
        deploymentCategory = m.createResource(BASE + "patterncategories/deployment");

        availability = m.createResource(BASE + "patterns/availability");
        scalability = m.createResource(BASE + "patterns/scalability");
        performance = m.createResource(BASE + "patterns/performance");
        cost = m.createResource(BASE + "patterns/cost");
        location = m.createResource(BASE + "patterns/location");

    }

}
