/*
* Copyright (c) 2017 Fraunhofer FOKUS.
* All rights reserved. This program and the accompanying materials
* are made available under the terms of the
* GNU AGPL v3 which accompanies
* this distribution, and is available at
* http://www.gnu.org/licenses/agpl.txt
*
* Contributors:
*
* Simon Dutkowski Fraunhofer FOKUS
*
* Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
*/

package eu.DECIDEh2020.architect.cloudpatterns.compendium.service;

import eu.DECIDEh2020.architect.cloudpatterns.Patterns;
import io.vertx.codegen.annotations.Fluent;
import io.vertx.codegen.annotations.ProxyGen;
import io.vertx.core.AsyncResult;
import io.vertx.core.Handler;
import io.vertx.core.Vertx;
import io.vertx.core.json.JsonArray;
import io.vertx.core.json.JsonObject;

@ProxyGen
public interface CloudPatternsService {

    static CloudPatternsService create(Patterns patterns, Handler<AsyncResult<CloudPatternsService>> readyHandler) {
        return new CloudPatternsServiceImpl(patterns, readyHandler);
    }

    static CloudPatternsService createProxy(Vertx vertx, String address) {
        return new CloudPatternsServiceVertxEBProxy(vertx, address);
    }

    @Fluent
    CloudPatternsService listPatterns(Handler<AsyncResult<JsonArray>> handler);

    @Fluent
    CloudPatternsService listNFRs(Handler<AsyncResult<JsonArray>> handler);

    @Fluent
    CloudPatternsService inferPatterns(JsonArray nfrs, Handler<AsyncResult<JsonArray>> handler);

    @Fluent
    CloudPatternsService getPattern(String name, Handler<AsyncResult<JsonObject>> handler);

}
